<template>
  <div class="gridOriginal">
    <header class="header">
      <slot name="heading"/>
    </header>

    <div class="sorting">
      <slot name="sorting"/>
    </div>

    <AppTable
      class="tableMain"
      :table-headings="$options.headings"
      :grid="grid"
      :has-lazy-load="hasLazyLoad"
      @load-data="$emit('load-data')"
      @order-change="$emit('order-change', $event)">
      <!--название бренда, артикул и название запчасти-->
      <template
        :slot="`unit-${$options.headings[0].name}`"
        slot-scope="{ part }">
        <template v-if="getItemExtUrl(part)">
          <a
            class="link linkNames"
            :href="getItemExtUrl(part)"
            target="_blank"
            @click="onClickExtUrl(part)"
            rel="nofollow">
            <div
              class="row __medium"
              v-tooltip="{
                classes: 'tooltip tooltipDark tooltipLinkSeller',
                content: 'Переход на сайт продавца',
                placement: 'right',
                trigger: 'hover',
                offset: 10,
                delay: 0 }">
              {{ part.brand }}, {{ part.vendor_code }}
              <img
                svg-inline
                src="~/assets/svg/redesign/exit.svg">
            </div>
            <div class="__all-wrap">{{ part.item_name | sellerPartName }}</div>
          </a>
        </template>

        <template v-else-if="showItemHrefs">
          <flink
            target="_blank"
            domain="main"
            class="link"
            :href="getItemHref(part)">
            <div class="row __medium">
              <span>{{ part.brand }}</span>
              <span class="dot circle-separator" />
              <span>{{ part.vendor_code }}</span>
            </div>
          </flink>

          <div class="__all-wrap">
            {{ part.item_name | sellerPartName }}
          </div>
        </template>

        <template v-else>
          <div class="row __medium">
            <span>{{ part.brand }}</span>
            <span class="dot circle-separator"/>
            <span>{{ part.vendor_code }}</span>
          </div>
          <div class="__all-wrap">{{ part.item_name | sellerPartName }}</div>
        </template>

      </template>

      <!--актуальность - дата добавления-->
      <template
        :slot="`unit-${$options.headings[2].name}`"
        slot-scope="{ part }">
        <div
          v-if="!part.is_outdated">
          {{ part.created_at | dateFormat({ nouns: true }) | capitalize }}
        </div>
        <div
          v-else
          class="sellerOutdated">
          Данные не обновлялись более&nbsp;14&nbsp;дней
        </div>
      </template>

      <!--наличие у продавца-->
      <template
        :slot="`unit-${$options.headings[3].name}`"
        slot-scope="{ part }">
        <AppSellerQuantity
          :in-stock="part.in_stock"
          :quantity="part.quantity"
          :under-order="part.delivery_string"/>
      </template>

      <!--информация о продавце - основная, которая видна всегда-->
      <template
        :slot="`unit-${$options.headings[4].name}`"
        slot-scope="{ part }">
        <div class="sellerInfoTable">
          <flink
            :href="`/seller/${part.shop_id}/${part.organization_id}?feedbacks=1#${part.part_id}`"
            target="_blank"
            class="link">
            <div class="sellerInfoTable-rating area-rating">
              <AppRating :current-rating="part.avg_rating"/>
              <span
                v-if="part.feedback_count"
                class="sellerReviews">
                {{ part.feedback_count }}
                {{ part.feedback_count | transChoose(['отзыв', 'отзыва', 'отзывов']) }}
              </span>
            </div>
          </flink>
          <div
            ref="hideArea"
            class="sellerInfoTable-name area-name __hide-shadow">
            <flink
              :href="`/seller/${part.shop_id}/${part.organization_id}#${part.part_id}`"
              target="_blank"
              class="link">
              <span
                ref="sellerName"
                class="sellerName __bold __no-wrap">
                {{ part.shop_name }}
                <img
                  v-if="part.contact_is_confirmed"
                  svg-inline
                  :class="{absolute: isIconAbsolute(part.shop_name.length)}"
                  src="~/assets/svg/redesign/ok-small-blue.svg">
              <!-- TODO: Тултип контент появится позже
                <span
                  class="sellerConfirmed"
                  v-tooltip="{
                    content: sellerConfirmedTooltipContent,
                    placement: 'bottom',
                    html: true,
                    trigger: 'hover',
                    offset: 4,
                    classes: 'tooltipDark',
                    delay: 0 }">
                  <img
                    v-if="part.contact_is_confirmed"
                    svg-inline
                    src="~/assets/svg/redesign/ok-small-blue.svg">
                </span> -->
              </span>
            </flink>
          </div>
          <AppWidgetChat
            v-if="!isAuthOwnItem(part)"
            class="area-chat"
            :button-text="`Чат`"
            :is-full="false"
            :id="part.shop_id"
            type="shop"
            @click.native="onClickChat(part)"/>
          <div class="sellerInfoTable-schedule area-schedule">
            <ScheduleOpenedNow :part="part"/>
          </div>
          <div class="sellerInfoTable-address area-address">
            <flink
              :href="`/seller/${part.shop_id}/${part.organization_id}`"
              target="_blank"
              @click.native="onClickSellerPage(part)"
              class="link">
              <span class="__no-wrap">{{ part.city_name }},</span>
              <span>{{ getItemAddress(part) }}</span>
            </flink>
          </div>
        </div>
      </template>

      <!--стоимость запчасти-->
      <template
        :slot="`unit-${$options.headings[5].name}`"
        slot-scope="{ part }">
        <AppSellerPrice
          :discount="part.discount_check"
          :price="part.price"
          :old-price="part.old_price"
          :is-wholesale="part.is_wholesale"/>
      </template>

      <!--кнопки для заказа-->
      <div
        :slot="`unit-${$options.headings[6].name}`"
        slot-scope="{ part }"
        class="sellerActions">
        <template
          v-if="!isAuthOwnItem(part)">
          <AppButton
            v-if="!getItemExtOrder(part)"
            :classes="['buttonOrder']"
            @click.native="onFastOrder(part)">
            <template #button-item>Быстрый заказ</template>
          </AppButton>
          <a
            v-if="getItemExtOrder(part)"
            :href="getItemExtOrder(part)"
            @click="onClickExtOrder(part)"
            target="_blank"
            rel="nofollow"
            class="button _blue linkAsButton">
            Перейти в магазин
          </a>

          <AppSocial
            :contacts="part.additional_contacts"
            @clicked="onClickMessengers(part)"/>
        </template>
        <div
          class="row"
          v-else>
          Это ваш товар
        </div>
      </div>
    </AppTable>
  </div>
</template>

<script>
import { mapState } from 'vuex';

import AppTable from '~/components/redesign/app-table/app-table';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppWidgetChat from '~/components/redesign/widget/app-widget-chat';
import AppSellerQuantity from '~/components/redesign/seller/app-seller-quantity';
import AppSellerPrice from '~/components/redesign/seller/app-seller-price';
import ScheduleOpenedNow from '~/components/blocks/schedule-opened-now';
import AppSocial from '~/components/redesign/app-social';
import AppRating from '~/components/redesign/app-rating';
import AppModalFastOrder from '~/components/redesign/app-modals/app-modal-fast-order';

// Model
import Item from '~/assets/js/model/item/item';

import mapFilters from '~/assets/js/helpers/map-filters';

// Structures
import Headings from '~/assets/js/structures/product/grid-original';

export default {
  name: 'GridOffers',
  components: {
    AppButton,
    AppTable,
    AppWidgetChat,
    AppSellerQuantity,
    AppSellerPrice,
    ScheduleOpenedNow,
    AppSocial,
    AppRating,
    AppModalFastOrder,
  },
  props: {
    grid: {
      type: Object,
      default() {
        return {};
      },
    },
    auth: {
      type: Object,
      default() {
        return {};
      },
    },
    showItemHrefs: {
      type: Boolean,
      default: false,
    },
    hasLazyLoad: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      iconAbsolute: false,
    };
  },
  computed: {
    ...mapState(['location']),
  },
  created() {
    this.$options.headings = Headings;
    this.$options.tooltipPartDiscountPrice = {
      content: 'Скажите, что вы с ГисАвто и получите скидку',
      placement: 'left-start',
      html: true,
      trigger: 'hover',
      offset: 4,
      classes: 'tooltipDark tooltipDiscount',
      delay: 0,
    };
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    getItemHref(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(item.brand));
      url.push(this.vendorCodeSlug(item.vendor_code));
      return url.join('/');
    },
    getItemAddress(item) {
      const result = [];

      if (item.is_netshop) {
        result.push('интернет магазин');
      } else {
        if (item.street) {
          result.push(item.street);
        }
        if (item.building) {
          result.push(item.building);
        }
        if (item.office) {
          result.push(`офис ${item.office}`);
        }
      }

      return result.join(', ');
    },
    isAuthOwnItem(item) {
      return Item.isOwnedByUser(this.auth && this.auth.id, new Item(item));
    },
    onFastOrder(item) {
      this.$emit('fast-order', item);
      this.$statPpn('click-order-quick', this.getItemStatData(item));
      this.$ym('to_order');
      this.$ga('Country1', 'Click32');
    },
    onClickSellerPage(item) {
      const data = this.getItemStatData(item);
      window.sessionStorage.setItem(`part${item.part_id}`, JSON.stringify(data));
      this.$statPpn('view-shop-card', data);
      this.$ym('contacts_in_ppn');
      this.$ga('Podrobnee', 'Click5');
    },
    onClickMessengers(item) {
      this.$statPpn('view-messenger', this.getItemStatData(item));
    },
    getItemStatData(item) {
      return {
        shopId: item.shop_id,
        brandId: item.part_manufacturer_id,
        partId: item.part_id,
        itemId: item.item_id,
        itemName: item.item_name,
        brandName: item.brand,
        partNumber: item.vendor_code,
        partName: item.part_name,
      };
    },
    getItemExtUrl(item) {
      if (item.item_redirect_url) {
        return item.item_redirect_url
          .replace('{brand}', item.brand_slug)
          .replace('{vendor_code}', this.vendorCodeSlug(item.vendor_code))
          .replace('{city}', this.location.slug ? this.location.slug : 'all_city');
      }
      return null;
    },
    getItemExtOrder(item) {
      if (item.order_redirect_url) {
        return item.order_redirect_url
          .replace('{brand}', item.brand_slug)
          .replace('{vendor_code}', this.vendorCodeSlug(item.vendor_code))
          .replace('{city}', this.location.slug ? this.location.slug : 'all_city');
      }
      return null;
    },
    onClickExtOrder(item) {
      this.$statPpn('click-external-url-order', this.getItemStatData(item));
      this.$ym('button_gotoshop');
    },
    onClickExtUrl(item) {
      this.$statPpn('click-external-url-name', this.getItemStatData(item));
      this.$ym('link_productname');
    },
    isIconAbsolute(length) {
      return length > 20;
    },
  },
};
</script>

<style scoped lang="postcss">
  .gridOriginal {
    .header {
      padding-bottom: 0.5rem;
    }

    @media screen and (max-width: 980px) {
      .header {
        padding: 1rem 1.25rem 0;
      }
      .sorting {
        position: relative;
        z-index: 10;
        padding: 0 1.25rem;
      }
    }

    @media screen and (min-width: 981px) {
      .sorting {
        display: none;
      }
    }
  }
</style>
